#include "dstring.h"
#include "operators.h"

int main()
{
	DString *tab[5];
	char c;
	int tmp, tmp2;
	char buf[256];

	for (int i=0; i<5; i++) tab[i]=0;

	cout << "		  DString demo v0.1 2003 by Jakub Madej";

	for(;;)
	{
		cout << endl << endl;
		for(int i=0; i<5; i++)
		{
			cout << i+1 << ": ";
			if (tab[i]) cout << *tab[i];
			else cout << "NULL";
			cout << "\n";
		}
		
		cout << "\nWybierz opcje:\n\n";
		cout << "u - utworz nowy obiekt         ";
		cout << "U - usun obiekt\n";
		cout << "n - nowy tekst                 ";
		cout << "d - dopisz\n";
		cout << "p - porownaj dwa obiekty       ";
		cout << "z - pobierz pojedynczy znak\n";
		cout << "k - konwertuj na int           ";
		cout << "K - konwertuj na double\n";
		cout << "w - wyczysc                    ";
		cout << "s - sprawdz, czy pusty\n";
		cout << "D - pobierz dlugosc            ";
		cout << "S - sprawdz, czy zawiera dany ciag\n";
		cout << "P - pobierz podciag            ";
		cout << "o - obetnij z prawej\n";
		cout << "O - obetnij z lewej            ";
		cout << "q - zakoncz\n";

		cin >> c;
		cin.ignore(1024,'\n');

		if (c=='q') break;
		else if (c=='u')
		{
			tmp=0;
			cout << "Podaj miejsce w tablicy:\n";
			cin >> tmp;
			cin.clear();
			cin.ignore(1024,'\n');

			if ((tmp<1) || (tmp>5))
			{
				cout << "Bledna wartosc!\n";
				continue;
			}
			if (tab[tmp-1]!=0)
			{
				cout << "To pole jest juz zajete!\n";
				continue;
			}

			cout << "Wybierz konstruktor:\n1 - DString()\n2 - DString(const DString&)\n3 - DString(const char*)\n";
			cin >> c;
			cin.ignore(1024,'\n');

			if (c=='1')
			{
				tab[tmp-1] = new DString();
				cout << "Gotowe!";
				continue;
			}

			if (c=='2')
			{
				tmp2=0;
				cout << "Podaj numer obiektu do skopiowania:";
				cin >> tmp2;
				cin.clear();
				cin.ignore(1024,'\n');
				if ((tmp2<1) || (tmp2>5))
				{
					cout << "Bledna wartosc!\n";
					continue;
				}
				if (tab[tmp2-1]==0)
				{
					cout << "Obiekt nie istnieje!\n";
					continue;
				}

				tab[tmp-1] = new DString(*tab[tmp2-1]);
				cout << "Gotowe!";
				continue;
			}

			if (c=='3')
			{
				cout << "Podaj tekst:";
				cin.getline(buf,256);
				tab[tmp-1] = new DString(buf);
				cout << "Gotowe!";
				continue;
			}
		}
		else if (c=='U')
		{
			tmp=0;
			cout << "Podaj nr obiektu:\n";
			cin >> tmp;
			cin.clear();
			cin.ignore(1024,'\n');
			
			if ((tmp<1) || (tmp>5))
			{
				cout << "Bledna wartosc!\n";
				continue;
			}
			if (tab[tmp-1]==0)
			{
				cout << "Obiekt nie istnieje!\n";
				continue;
			}

			delete tab[tmp-1];
			tab[tmp-1]=0;
			cout << "Gotowe!";
			continue;
		}
		else if (c=='n')
		{
			tmp=0;
			cout << "Podaj nr obiektu:\n";
			cin >> tmp;
			cin.clear();
			cin.ignore(1024,'\n');
			
			if ((tmp<1) || (tmp>5))
			{
				cout << "Bledna wartosc!\n";
				continue;
			}
			if (tab[tmp-1]==0)
			{
				cout << "Obiekt nie istnieje!\n";
				continue;
			}

			cout << "Podaj tekst:";
			cin >> *tab[tmp-1];
			cin.ignore(1024,'\n');
			cout << "Gotowe!";
			continue;
		}
		else if (c=='d')
		{
			tmp=0;
			cout << "Podaj nr obiektu:\n";
			cin >> tmp;
			cin.clear();
			cin.ignore(1024,'\n');
			
			if ((tmp<1) || (tmp>5))
			{
				cout << "Bledna wartosc!\n";
				continue;
			}
			if (tab[tmp-1]==0)
			{
				cout << "Obiekt nie istnieje!\n";
				continue;
			}

			cout << "Podaj tekst:";
			cin.getline(buf,256);
			*tab[tmp-1]=*tab[tmp-1]+buf;
			cout << "Gotowe!";
			continue;
		}
		else if (c=='p')
		{
			tmp=0;
			tmp2=0;
			cout << "Podaj nr obiektow do porownania:\n";
			cin >> tmp >> tmp2;
			cin.clear();
			cin.ignore(1024,'\n');
			
			if ((tmp<1) || (tmp>5) || (tmp2<1) || (tmp2>5))
			{
				cout << "Bledne wartosci!\n";
				continue;
			}
			if ((tab[tmp-1]==0) || (tab[tmp2-1]==0))
			{
				cout << "Jeden z obiektow nie istnieje!\n";
				continue;
			}

			if (*tab[tmp-1]==*tab[tmp2-1]) cout << "Obiekty sa takie same.";
			else cout << "Obiekty roznia sie.";
			continue;
		}
		else if (c=='z')
		{
			tmp=0;
			cout << "Podaj nr obiektu:\n";
			cin >> tmp;
			cin.clear();
			cin.ignore(1024,'\n');
			
			if ((tmp<1) || (tmp>5))
			{
				cout << "Bledna wartosc!\n";
				continue;
			}
			if (tab[tmp-1]==0)
			{
				cout << "Obiekt nie istnieje!\n";
				continue;
			}

			cout << "Podaj indeks znaku:\n";
			tmp2=-1;
			cin >> tmp2;
			cin.clear();
			cin.ignore(1024,'\n');

			if (tmp2<0)
			{
				cout << "Bledna wartosc!";
				continue;
			}

			cout << "Pobrany znak: " << (*tab[tmp-1])[tmp2];

			continue;
		}
		else if (c=='k')
		{
			tmp=0;
			cout << "Podaj nr obiektu:\n";
			cin >> tmp;
			cin.clear();
			cin.ignore(1024,'\n');
			
			if ((tmp<1) || (tmp>5))
			{
				cout << "Bledna wartosc!\n";
				continue;
			}
			if (tab[tmp-1]==0)
			{
				cout << "Obiekt nie istnieje!\n";
				continue;
			}

			cout << "Rezultat: " << (*tab[tmp-1]).asInt();
			continue;
		}
		else if (c=='K')
		{
			tmp=0;
			cout << "Podaj nr obiektu:\n";
			cin >> tmp;
			cin.clear();
			cin.ignore(1024,'\n');
			
			if ((tmp<1) || (tmp>5))
			{
				cout << "Bledna wartosc!\n";
				continue;
			}
			if (tab[tmp-1]==0)
			{
				cout << "Obiekt nie istnieje!\n";
				continue;
			}

			cout << "Rezultat: " << (*tab[tmp-1]).asDouble();
			continue;
		}
		else if (c=='w')
		{
			tmp=0;
			cout << "Podaj nr obiektu:\n";
			cin >> tmp;
			cin.clear();
			cin.ignore(1024,'\n');
			
			if ((tmp<1) || (tmp>5))
			{
				cout << "Bledna wartosc!\n";
				continue;
			}
			if (tab[tmp-1]==0)
			{
				cout << "Obiekt nie istnieje!\n";
				continue;
			}

			(*tab[tmp-1]).empty();
			cout << "Gotowe!";
			continue;
		}
		else if (c=='s')
		{
			tmp=0;
			cout << "Podaj nr obiektu:\n";
			cin >> tmp;
			cin.clear();
			cin.ignore(1024,'\n');
			
			if ((tmp<1) || (tmp>5))
			{
				cout << "Bledna wartosc!\n";
				continue;
			}
			if (tab[tmp-1]==0)
			{
				cout << "Obiekt nie istnieje!\n";
				continue;
			}

			if ((*tab[tmp-1]).IsEmpty()) cout << "Pusty!";
			else cout << "Niepusty!";
			continue;
		}
		else if (c=='D')
		{
			tmp=0;
			cout << "Podaj nr obiektu:\n";
			cin >> tmp;
			cin.clear();
			cin.ignore(1024,'\n');
			
			if ((tmp<1) || (tmp>5))
			{
				cout << "Bledna wartosc!\n";
				continue;
			}
			if (tab[tmp-1]==0)
			{
				cout << "Obiekt nie istnieje!\n";
				continue;
			}

			cout << "Rezultat: " << (*tab[tmp-1]).getLen();
			continue;
		}
		else if (c=='S')
		{
			tmp=0;
			cout << "Podaj nr obiektu:\n";
			cin >> tmp;
			cin.clear();
			cin.ignore(1024,'\n');
			
			if ((tmp<1) || (tmp>5))
			{
				cout << "Bledna wartosc!\n";
				continue;
			}
			if (tab[tmp-1]==0)
			{
				cout << "Obiekt nie istnieje!\n";
				continue;
			}

			cout << "Podaj szukany tekst:\n";
			cin.getline(buf, 256);
			if ((*tab[tmp-1]).IsString(buf)) cout << "Zawiera!";
			else cout << "Nie zawiera.";
			continue;
		}
		else if (c=='P')
		{
			tmp=0;
			cout << "Podaj nr obiektu:\n";
			cin >> tmp;
			cin.clear();
			cin.ignore(1024,'\n');
			
			if ((tmp<1) || (tmp>5))
			{
				cout << "Bledna wartosc!\n";
				continue;
			}
			if (tab[tmp-1]==0)
			{
				cout << "Obiekt nie istnieje!\n";
				continue;
			}

			int left=-1;
			int right=-1;
			cout << "Podaj lewa i prawa granice przedzialu:\n";
			cin >> left >> right;
			cin.clear();
			if ((left<0) || (right<0))
			{
				cout << "Bledne wartosci!\n";
				continue;
			}

			cout << "Rezultat: " << (*tab[tmp-1]).GetString(left, right);
			continue;
		}
		else if (c=='o')
		{
			tmp=0;
			cout << "Podaj nr obiektu:\n";
			cin >> tmp;
			cin.clear();
			cin.ignore(1024,'\n');
			
			if ((tmp<1) || (tmp>5))
			{
				cout << "Bledna wartosc!\n";
				continue;
			}
			if (tab[tmp-1]==0)
			{
				cout << "Obiekt nie istnieje!\n";
				continue;
			}

			tmp2=-1;
			cout << "Podaj ilosc znakow:\n";
			cin >> tmp2;
			cin.clear();
			cin.ignore(1024,'\n');
			if (tmp2<0)
			{
				cout << "Bledna wartosc!\n";
				continue;
			}

			*tab[tmp-1]=(*tab[tmp-1]).TrimRight(tmp2);
			continue;
		}
		else if (c=='O')
		{
			tmp=0;
			cout << "Podaj nr obiektu:\n";
			cin >> tmp;
			cin.clear();
			cin.ignore(1024,'\n');
			
			if ((tmp<1) || (tmp>5))
			{
				cout << "Bledna wartosc!\n";
				continue;
			}
			if (tab[tmp-1]==0)
			{
				cout << "Obiekt nie istnieje!\n";
				continue;
			}

			tmp2=-1;
			cout << "Podaj ilosc znakow:\n";
			cin >> tmp2;
			cin.clear();
			cin.ignore(1024,'\n');
			if (tmp2<0)
			{
				cout << "Bledna wartosc!\n";
				continue;
			}

			*tab[tmp-1]=(*tab[tmp-1]).TrimLeft(tmp2);
			continue;
		}


		cout << "Bledna opcja!\n\n";
	}

	return 0;
}
