#include "list.h"

List::List()
{
	head=tail=0;
	itemsCounter=0;
}

int List::IsEmpty() const
{
	return (itemsCounter==0);
}

void List::RemoveAll()
{
	while (itemsCounter) removeFrom(1);
}

void List::addHead()
{
	ListElement* tmp = createNewElement();
	if (IsEmpty())
	{
		head=tail=tmp;
		itemsCounter=1;
	}
	else
	{
		tmp->SetNext(head);
		head=tmp;
		itemsCounter++;
	}
}

void List::deleteHead()
{
	removeFrom(1);
}

void List::addTail()
{
	if (IsEmpty()) addHead();
	else
	{
		ListElement* tmp = createNewElement();
		tail->SetNext(tmp);
		tail=tmp;
		itemsCounter++;
	}
}

void List::deleteTail()
{
	removeFrom(itemsCounter);
}

int List::insertAt(int n)
{
	if (n>=1 && (unsigned)n<=itemsCounter+1)
	{
		ListElement* tmp = createNewElement();
		if (n==1)
		{
			tmp->SetNext(head);
			head=tmp;
			itemsCounter++;
			if (itemsCounter==1) tail=head;
		}
		else if ((unsigned)n==itemsCounter+1)
		{
			tail->SetNext(tmp);
			tail=tmp;
			itemsCounter++;
			if (itemsCounter==1) head=tail;
		}
		else
		{
			ListElement*tmp2=get(n-1);
			tmp->SetNext(tmp2->GetNext());
			tmp2->SetNext(tmp);
			itemsCounter++;
		}
		return 1;
	}
	return 0;
}

int List::removeFrom(int n)
{
	if (n>=1 && (unsigned)n<=itemsCounter)
	{
		ListElement*toremove;
		if (n==1)
		{
			toremove=head;
			head=head->GetNext();
		}
		else
		{
			toremove=get(n-1)->GetNext();
			get(n-1)->SetNext(toremove->GetNext());
		}
		delete toremove;
		itemsCounter--;
		tail=findNewTail();
		return 1;
	}
	return 0;
}

ListElement* List::get(int n)const
{
	if (n>=1 && (unsigned)n<=itemsCounter)
	{
		ListElement*tmp=head;
		for(int i=1; i<n; i++, tmp=tmp->GetNext());
		return tmp;
	}
	return 0;
}

ListElement* List::getHead() const
{
	return head;
}

ListElement* List::getTail() const
{
	return tail;
}

ListElement* List::findNewTail() const
{
	return get(itemsCounter);
}

ListElement* List::createNewElement()
{
	return new ListElement;
}

void List::free()
{
	RemoveAll();
}
