#include "listiterator.h"

ListIterator::ListIterator(const List& alist)
{
	start=alist.getHead();
	cursor=start;
	if (cursor) position=1;
	else position=0;
}

int ListIterator::AtEnd() const
{
	if (!cursor) return 1;
	return (cursor->GetNext()==0);
}

void ListIterator::Restart()
{
	cursor=start;
	if (cursor) position=1;
	else position=0;
}

ListElement* ListIterator::get()
{
	return cursor;
}

ListIterator& ListIterator::advance()
{
	if (!AtEnd())
	{
		cursor=cursor->GetNext();
		position++;
	}
	return *this;
}

ListIterator& ListIterator::operator=(const ListIterator& other)
{
	start=other.start;
	cursor=other.cursor;
	position=other.position;
	return *this;
}

ListIterator& ListIterator::operator=(const List& alist)
{
	ListIterator tmp(alist);
	return *this=tmp;
}
