#include "objectlist.h"
#include "objectlistiterator.h"

ObjectList::ObjectList() {}
 
void ObjectList::AddHead(Object* ptr)
{
	addHead();
	((ObjectListElement*)head)->Set(ptr);
}

void ObjectList::AddTail(Object* ptr)
{
	addTail();
	((ObjectListElement*)tail)->Set(ptr);
}

int ObjectList::InsertAt(int n,Object* ptr)
{
	if (insertAt(n))
	{
		((ObjectListElement*)get(n))->Set(ptr);
		return 1;
	}
	return 0;
}

int ObjectList::RemoveFrom(int n)
{
	return removeFrom(n);
}

int ObjectList::GetPosition(const Object* ptr)
{
	if (ptr && !IsEmpty())
	{
		ObjectListIterator tmp(*this);
		for(;;)
		{
			if (tmp.Get()==ptr) return tmp.getPosition();
			if (tmp.AtEnd()) return 0;
			tmp++;
		}
	}
	return -1;
}

Object* ObjectList::GetHead() const
{
	return ((ObjectListElement*)getHead())->Get();
}

Object* ObjectList::GetTail() const
{
	return ((ObjectListElement*)getTail())->Get();
}

Object* ObjectList::Get(int n)const
{
	ObjectListElement*tmp=(ObjectListElement*)get(n);
	if (tmp) return tmp->Get();
	return 0;
}

ListElement* ObjectList::createNewElement()
{
	return new ObjectListElement;
}

ObjectListPosition ObjectList::getHeadPosition()const
{
	return (ObjectListPosition)getHead();
}

ObjectListPosition ObjectList::getNextPosition(const ObjectListPosition pos)
{
	if (pos) return (ObjectListPosition)pos->GetNext();
	return 0;
}

Object* ObjectList::getObjectAt(const ObjectListPosition pos)
{
	return pos->Get();
}
