#if !defined _objectlist
#define _objectlist

#include "objectlistelement.h"
#include "list.h"

typedef ObjectListElement*ObjectListPosition;

class ObjectList: public List
{
 friend class ObjectListIterator;

 public:
 ObjectList();
 virtual ~ObjectList() {}
 
 void AddHead(Object* ptr);
 void AddTail(Object* ptr);
 int InsertAt(int n,Object* ptr);
 int RemoveFrom(int n);
 int GetPosition(const Object* ptr);          //return -1 if not exist
 Object* GetHead() const;
 Object* GetTail() const;
 Object* Get(int n)const;

 protected:
 virtual ListElement* createNewElement();
public:
	ObjectListPosition getHeadPosition()const;
	static ObjectListPosition getNextPosition(const ObjectListPosition pos );
	static Object* getObjectAt(const ObjectListPosition pos);
};

#endif
